<script lang="ts">
import Vue from 'vue';
import { getNavigationClient } from '~/plugins/contentful';
import { NAV_CONTENT_TYPES } from '~/common/content-types';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { IsMobileMixin } from '~/mixins';
import ColoredLine from '~/components/common/colored-line.vue';

export default Vue.extend({
  name: 'TheSourceNavigation',
  components: { ColoredLine },
  mixins: [IsMobileMixin],
  data() {
    return {
      navigation: null,
      isMenuOpen: false,
      coloredLine: [
        { color: '#FCA326', width: '20%' },
        { color: '#6FDAC9', width: '15%' },
        { color: '#E24329', width: '25%' },
        { color: '#A989F5', width: '20%' },
        { color: '#FCA326', width: '20%' },
      ],
    };
  },
  async fetch() {
    const { items } = await getNavigationClient().getEntries({
      content_type: NAV_CONTENT_TYPES.NAVIGATION,
      'sys.id': '5kvhr6HHjfYXiHS3CkgO7b', // The Source Navigation
      include: 3,
      locale: convertToCaseSensitiveLocale(this.$i18n.locale),
    });

    const [nav] = items;

    this.navigation = nav.fields;
  },
  computed: {
    navItems() {
      return this.navigation?.navItems?.map((item) => item.fields);
    },
    subscribeButton() {
      return this.navigation?.freeTrial?.fields;
    },
  },
  methods: {
    toggleMenu() {
      this.isMenuOpen = !this.isMenuOpen;
    },
  },
});
</script>

<template>
  <section class="ts-nav">
    <ColoredLine :line-colors="coloredLine" />
    <SlpContainer>
      <nav>
        <!--DESKTOP-->
        <div v-show="!isMobile" class="ts-nav-desktop">
          <div class="slp-flex">
            <SlpButton
              class="ts-nav-desktop__logo"
              href="/the-source/"
              variant="tertiary"
            >
              <img
                src="/nuxt-images/the-source/the-source-logo.svg"
                alt="The Source Logo"
              />
            </SlpButton>
            <ul class="ts-nav-desktop__links">
              <li
                v-for="(navItem, index) in navItems"
                :key="`${navItem.text}-${index}`"
              >
                <SlpButton
                  :class="[
                    'ts-nav-desktop__link',
                    {
                      'ts-nav-desktop__link--active':
                        navItem.href === $route.path,
                    },
                  ]"
                  variant="ghost"
                  :href="navItem.href"
                  :name="navItem.text"
                >
                  {{ navItem.text }}
                </SlpButton>
              </li>
            </ul>
          </div>
          <div>
            <SlpButton
              v-if="subscribeButton"
              variant="primary"
              :href="subscribeButton.href"
              :name="subscribeButton.text"
            >
              {{ subscribeButton.text }}
            </SlpButton>
          </div>
        </div>
        <!--MOBILE-->
        <div v-show="isMobile" class="ts-nav-mobile">
          <div v-if="!isMenuOpen" class="ts-nav-mobile__main">
            <SlpButton
              href="/the-source/"
              variant="tertiary"
              data-nav="logo"
              aria-label="Home"
              name="Home"
            >
              <img
                src="/nuxt-images/the-source/the-source-logo.svg"
                alt="The Source Logo"
              />
            </SlpButton>
            <div>
              <SlpButton
                v-if="subscribeButton"
                class="ts-nav-mobile__subscribe"
                variant="primary"
                :href="subscribeButton.href"
                :name="subscribeButton.text"
              >
                {{ subscribeButton.text }}
              </SlpButton>
              <SlpButton
                class="ts-nav-mobile__hamburger"
                variant="icon"
                @click.native="toggleMenu"
              >
                <SlpIcon
                  variant="product"
                  name="hamburger"
                  size="sm"
                  slp-color="text-300"
                />
              </SlpButton>
            </div>
          </div>
          <ul v-else class="ts-nav-mobile__menu">
            <li class="ts-nav-mobile__back">
              <SlpButton variant="icon" @click.native="toggleMenu">
                <SlpIcon name="chevron-left" variant="product" size="md" />
              </SlpButton>
            </li>
            <li
              v-for="(item, index) in navItems"
              :key="`${item.text}-${index}`"
              class="ts-nav-mobile__link"
            >
              <SlpButton variant="ghost" :href="item.href" :name="item.text">
                <SlpTypography tag="span" variant="body1">
                  {{ item.text }}
                </SlpTypography>
              </SlpButton>
            </li>
          </ul>
        </div>
      </nav>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.ts-nav {
  position: sticky;
  top: 0;
  background-color: $color-surface-50;
  z-index: $zindex-sticky;

  &-desktop {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: $spacing-16 0;
    width: 100%;
    position: sticky;

    .slp-container {
      padding: 0;
    }

    &__links {
      display: flex;
      align-items: center;
    }

    &__logo {
      padding: 0;
      margin-right: $spacing-16;
    }

    &__link {
      color: $color-text-300;
      transition: all 0.2s ease;
      padding: 0 $spacing-16;
      font-weight: 600;

      &--active {
        text-decoration: underline;
        text-decoration-color: $color-text-link-100;
        text-underline-offset: 4px;
      }

      &:hover {
        text-decoration: underline;
        text-decoration-color: $color-text-link-100;
        text-underline-offset: 4px;
      }
    }
  }

  &-mobile {
    &__main {
      display: flex;
      justify-content: space-between;
      align-items: center;
    }

    &__subscribe {
      padding-top: $spacing-8;
      padding-bottom: $spacing-8;
    }

    &__hamburger {
      margin: 0;
      padding: 0 0 0 $spacing-16;
    }

    &__menu {
      background-color: white;
      bottom: 0;
      left: 0;
      right: 0;
      top: 0;
      display: flex;
      flex-direction: column;
      max-width: 100vw;
      overflow-x: hidden;
      position: fixed;
      z-index: 100;
    }

    &__link {
      border-bottom: 1px solid $color-surface-300;
      margin: 0 $spacing-16 0 $spacing-32;
    }

    &__back {
      border-bottom: 1px solid $color-surface-300;
      margin: 0 $spacing-16;
    }

    &__link,
    &__back {
      .slp-btn {
        width: 100%;
        color: $color-text-300;
        padding: $spacing-16 0;
      }
    }
  }
}
</style>
